//!

const std = @import("std");

///
pub const Self  = @This();

///
pub const Error = error {
    ///
    AllocationFailure,

    ///
    InvalidState,

    ///
    Unknown,
};

///
pub const VTable = struct {
    ///
    deinit: *const fn(ctx: *anyopaque) void,

    ///
    apply: *const fn(ctx: *anyopaque) Error!void,

    ///
    revert: *const fn(ctx: *anyopaque) Error!void,
};

///
ctx: *anyopaque,

///
vtable: *const VTable,

///
pub fn deinit(self: Self) void {
    self.vtable.deinit(self.ctx);
}

///
pub fn apply(self: Self) !void {
    return self.vtable.apply(self.ctx);
}

///
pub fn revert(self: Self) !void {
    return self.vtable.revert(self.ctx);
}
